package pencilboxex;

import java.lang.reflect.InvocationTargetException;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

import pencilbox.common.core.BoardBase;
import pencilbox.common.gui.Frame;

/**
 * NA~ʕ\ȂǂT|[g_CAO
 */
public final class GeneratorDialog extends TaskDialog {
	
	/** ^Cg */
	private static final String TITLE = "";
	
	/**  */
	private GeneratorBase generator = null;
	/** Ֆ */
	private BoardBase board = null;

	/**
	 * \o[N̈A̗s
	 * 
	 * @param frame _CAO̐et[
	 * @param solver \o[
	 * @param board Ֆ
	 * @return 
	 */
	public static void start(final Frame frame, final GeneratorBase generator, final BoardBase board) {
		GeneratorDialog dialog = new GeneratorDialog(frame, generator, board);
		
		generator.setDialog(dialog);
		
		dialog.pack();
		dialog.setLocationRelativeTo(frame);
		
		dialog.start();
		
		if (dialog.thread != null) {
			dialog.setVisible(true);
		}
		
		//
		String errMessage = dialog.getErrMessage();
		
		if (errMessage != null && errMessage.length() > 0) {
			JOptionPane.showMessageDialog(frame, "̓G[F" + dialog.getErrMessage(), TITLE, JOptionPane.ERROR_MESSAGE);
		}
	}
	
	/**
	 * RXgN^
	 * 
	 * @param frame _CAO̐et[
	 * @param solver \o[
	 * @param board Ֆ
	 */
	private GeneratorDialog(Frame frame, GeneratorBase generator, BoardBase board) {
		super(frame, TITLE, true);
		this.generator = generator;
		this.board = board;
		setText("s");
	}
	
	/**
	 * \o[NAIʂ
	 */
	public void run() {
		
		//lLZƂ
		try {
			long time = System.nanoTime();
			generator.generate(board);
			try {
				SwingUtilities.invokeAndWait(new Runnable() {
					public void run() {
						generator.updateBoard(board);
					}
				});
			} catch (InvocationTargetException e) {
			}
			System.out.println(((System.nanoTime() - time) / 1000000) + "ms");
			getFrame().repaint();
		} catch (InterruptedException e) {
		} catch (RuntimeException e) {
			e.printStackTrace();
			setErrMessage(e.toString());
		} finally {
			synchronized (this) {
				thread = null;
				//ʂ
				setVisible(false);
			}
		}
	}
}
