package solver.shikaku;

/**
 * lpɐ؂̃\o[ŗplp̃NX
 */
public final class Rect {
	
	/** ӂxW */
	public final int left;
	/** EӂxW */
	public final int right;
	/** ӂyW */
	public final int top;
	/** ӂyW */
	public final int bottom;
	/** ݂̕ */
	public final int width;
	/** ݂̍ */
	public final int height;
	/** ݂̖ʐ */
	public final int area;
	/**  */
	public final int number;
	/** ʐς𖄂߂ǂ */
	public final boolean complete;
	
	/**
	 * RXgN^
	 * 
	 * @param x
	 * @param y
	 * @param number
	 */
	public Rect(final int x, final int y, final int number) {
		this(x, x, y, y, number);
	}

	/**
	 * RXgN^
	 * 
	 * @param left ӂxW
	 * @param right EӂxW
	 * @param top ӂyW
	 * @param bottom ӂyW
	 * @param number 
	 */
	public Rect(final int left, final int right, final int top, final int bottom, final int number) {
		this.left = left;
		this.right = right;
		this.top = top;
		this.bottom = bottom;
		this.number = number;
		this.width = right - left + 1;
		this.height = bottom - top + 1;
		this.area = width * height;
		this.complete = area == number;
	}
	
	/**
	 * `̍WύXlp𐶐ĕԂ܂
	 * 
	 * @param left ӂxW
	 * @param right EӂxW
	 * @param top ӂyW
	 * @param bottom ӂyW
	 * @return ύXlp
	 */
	public Rect change(final int left, final int right, final int top, final int bottom) {
		return new Rect(left, right, top, bottom, number);
	}
	
	/**
	 * `̍WύXlp𐶐ĕԂ܂
	 * 
	 * @param left ӂxW
	 * @param right EӂxW
	 * @param top ӂyW
	 * @param bottom ӂyW
	 * @return ύXlp
	 */
	public Rect change(final int x, final int y) {
		return new Rect(
				(x < this.left) ? x : this.left,
				(this.right < x) ? x : this.right,
				(y < this.top) ? y : this.top,
				(this.bottom < y) ? y : this.bottom,
				number);
	}
	
	/**
	 * `̍WύXlp𐶐ĕԂ܂
	 * 
	 * @param left ӂxW
	 * @param right EӂxW
	 * @param top ӂyW
	 * @param bottom ӂyW
	 * @return ύXlp
	 */
	public Rect change(final int number) {
		return new Rect(left, right, top, bottom, number);
	}
	
	/**
	 * IuWFNg̕\Ԃ܂
	 * 
	 * @return IuWFNg̕\
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "[" + left + "-" + right + ", " + top + "-" + bottom + ", " + number + "]";
	}
	
	/**
	 * ̃IuWFNgƁuvɂȂIuWFNg邩ǂԂ܂
	 * 
	 * @param obj rΏۂ̎QƃIuWFNg 
	 * @return Ɏw肳ꂽIuWFNgƂ̃IuWFNgꍇ trueAłȂꍇ false
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(final Object obj) {
		
		if (this == obj) return true;
		if (obj == null) return false;
		if (!obj.getClass().equals(Rect.class)) return false;
		final Rect rect = (Rect)obj;
		//NXϐr
		
		return rect.left == this.left
				&& rect.right == this.right
				&& rect.top == this.top
				&& rect.bottom == this.bottom
				&& rect.number == this.number;
	}
	
	/**
	 * nbVR[hlԂ܂
	 * 
	 * @return nbVR[hl
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return left + right + top + bottom + number;
	}
}
