package solver.shikaku;

import java.util.Arrays;

/**
 * lpɐ؂̉\NX
 */
public class ShikakuResult {
	
	/** lp̔z */
	private final Rect[] rectArray;
	/**  */
	private final Rect[] history;
	
	/**
	 * RXgN^
	 * 
	 * @param rectArray lp̔z
	 */
	public ShikakuResult(Rect[] rectArray) {
		this(rectArray, null);
	}
	/**
	 * RXgN^
	 * 
	 * @param rectArray lp̔z
	 */
	public ShikakuResult(Rect[] rectArray, Rect[] history) {
		if (rectArray == null) {
			throw new NullPointerException();
		}
		
		this.rectArray = new Rect[rectArray.length];
		
		for (int i = 0; i < rectArray.length; ++i) {
			this.rectArray[i] = rectArray[i];
		}
		if (history != null) {
			this.history = new Rect[history.length];
			
			for (int i = 0; i < history.length; ++i) {
				this.history[i] = history[i];
			}
		} else {
			this.history = null;
		}
	}
	
	/**
	 * lp̌Ԃ܂
	 * 
	 * @return lp̌
	 */
	public int count() {
		return rectArray.length;
	}
	
	/**
	 * Ŏw肳ꂽCfbNX̎lpԂ܂
	 * 
	 * @param index CfbNX
	 * @return w肳ꂽlp
	 */
	public Rect getRect(int index) {
		return rectArray[index];
	}
	
	
	public int getHistoryCount() {
		return (history == null) ? 0 : history.length;
	}
	
	/**
	 * Ŏw肳ꂽCfbNX̎lpԂ܂
	 * 
	 * @param index CfbNX
	 * @return w肳ꂽlp
	 */
	public Rect getHistory(int index) {
		return history[index];
	}
	
	/**
	 * ̃IuWFNgƁuvɂȂIuWFNg邩ǂԂ܂
	 * 
	 * @param obj rΏۂ̎QƃIuWFNg 
	 * @return Ɏw肳ꂽIuWFNgƂ̃IuWFNgꍇ trueAłȂꍇ false
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object obj) {
		
		if (this == obj) return true;
		if (obj == null) return false;
		if (!obj.getClass().equals(ShikakuResult.class)) return false;
		ShikakuResult result = (ShikakuResult)obj;
		//NXϐr
		return Arrays.equals(this.rectArray, result.rectArray);
	}
	
	/**
	 * nbVR[hlԂ܂
	 * 
	 * @return nbVR[hl
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return Arrays.hashCode(rectArray);
	}
}
