package pencilboxex;

import pencilbox.common.core.BoardBase;

/**
 * \o[̊NX
 */
public abstract class GeneratorBase {
	
	/** _CAO */
	private GeneratorDialog dialog = null;
	
	
	/**
	 * 𓚂Ȃ
	 * 
	 * @param board Ֆ
	 * @return 
	 * @throws InterruptedException ̃\bhsĂXbhfꂽꍇ
	 */
	public abstract void generate(BoardBase board) throws InterruptedException;
	
	
	/**
	 * 
	 * @param board
	 */
	public abstract void updateBoard(BoardBase board);
	
	/**
	 * bZ[Wݒ肷
	 * 
	 * @param message bZ[W
	 */
	public void setMessage(String message) {
		if (dialog != null) {
			dialog.setMessage(message);
		}
	}
	
	/**
	 * G[bZ[Wݒ肷
	 * 
	 * @param message bZ[W
	 */
	protected void setErrMessage(String string) {
		if (dialog != null) {
			dialog.setErrMessage(string);
		}
	}

	/**
	 * _CAO擾
	 * 
	 * @return _CAO
	 */
	public GeneratorDialog getDialog() {
		return dialog;
	}
	
	/**
	 * _CAOݒ肷
	 * 
	 * @param dialog _CAO
	 */
	public void setDialog(GeneratorDialog dialog) {
		this.dialog = dialog;
	}
}
